/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : vendredi 01 juin 2007 - 16h22
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : MeanGestures.cpp
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/

#include <QPainter>
#include <QLabel>
#include <QComboBox>
#include <QString>

#include "meanGestures.h"
#include "MarkDrawing.h"

//===================================================
//===================================================
//===================================================
MeanGesturesSheet::MeanGesturesSheet(QWidget * _parent) :QWidget(_parent){
	resize(350,400);
	numItemFilter = -1;
	QLabel * numItemLabel = new QLabel("num item :", this);
	numItemLabel->move(0,0);
	
	QComboBox* numItemBox = new QComboBox(this);
	for(int i=-1; i<= 56; i++){
		QString nameItem;
		if(i!=-1){
			nameItem.setNum(i);
			nameItem = "item "+ nameItem;
		}else{
			nameItem = " all items";
		}
		numItemBox->addItem(nameItem);
	}
	numItemBox->move (50, 0);
	connect(numItemBox, SIGNAL( activated( int ) ), this, SLOT( selectNumItemFilter(int) ) );
	connect(numItemBox, SIGNAL( highlighted( int ) ), this, SLOT( selectNumItemFilter(int) ) );
}

//=========================
MeanGesturesSheet::~MeanGesturesSheet(){}

//=========================
void MeanGesturesSheet::selectNumItemFilter(int i){
	numItemFilter = i-1;
	update();
}

//=========================
void MeanGesturesSheet::paintEvent(QPaintEvent * e){
	QPainter p(this);
	int longeurMark = 150;
	QPen pen;
	pen.setWidth(1);
	pen.setColor(Qt::lightGray);
	p.setPen(pen);
	MarkDrawing::drawPie(p, width()/2, height()/2 + 25, longeurMark+30, 8);
	
	
	pen.setColor(Qt::black);
	p.setPen(pen);
	
	for(unsigned int i= 0; i < 56; i++){
		
		if(  i>=40 ){
			longeurMark = 110;
		}else{
			longeurMark = 150;
		}
		
		if( numItemFilter == -1 || numItemFilter == i ){
			MarkDrawing::drawMark(p, width()/2, height()/2 +25, longeurMark, i);
		}
		
	}
	
	
	
	
	//p.drawRect(10,10,100,100);
}


//===================================================
//===================================================
//===================================================
MeanGestures::MeanGestures(QWidget* _parent):QDialog( _parent ){
	resize(350,400);
	move(0,0);
	sheet = new MeanGesturesSheet( this );
}


//==========================
MeanGestures::~MeanGestures(){}

//===========================


