/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : mercredi 23 mai 2007 - 13h40
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : GMConfiguration.cpp
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/
#include <iostream>
#include "GMConfiguration.h"
#include "FlowerGroupingMenu.h"

using namespace std;

//===================
GMConfiguration::GMConfiguration(FlowerGroupingMenu* _menu): menu(_menu){
	
}

//====================
GMConfiguration::~GMConfiguration(){
	
}


//=====================
void GMConfiguration::defineConfiguration(int * _dir, int * _branch, int nb){
	for(int i =0; i < nb; i++){
		dirSector.push_back( _dir[i] );
		branchSector.push_back( _branch[i] );
	}
}

//int tabDir[] =   { 0,0, 0,0, 2, 2, 2, 2, 4, 4, 4,4, 6, 6, 6, 6};
//int tabBrch[] = {1, 2,3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4};
//=====================
bool GMConfiguration::hasOnAxes(){
	bool res = false;
	for(unsigned int i = 0; i< dirSector.size(); i++){
		int dir = dirSector[i];
		if( dir == 0 || dir == 2 || dir == 4 || dir == 6){
			res = true;
		}
	}
	return res;
}

//=====================
bool GMConfiguration::hasOffAxes(){
	bool res = false;
	for(unsigned int i = 0; i< dirSector.size(); i++){
		int dir = dirSector[i];
		if( dir == 1 || dir == 3 || dir == 5 || dir == 7){
			res = true;
		}
	}
	return res;
}

//======================
//if no elem in _dir return -1;
//if elem in _dir && elem dir +1 et dir -1 return 1
//if elem in _dir sans elem en dir+1 et dir-1 retur 2
int GMConfiguration::getAmplForDir(int _dir){
	
	int res = -1;
	bool bDir = false;
	bool bDirPlus = false;
	bool bDirMoins = false;
	
	
	for(unsigned int i =0; i < dirSector.size() ; i ++){
		if (_dir == dirSector[i] ) {
			bDir = true;
		}
		
		if( (_dir + 1) == dirSector[i] ) bDirPlus = true;
		if ( (_dir  - 1) == dirSector[i] ) bDirMoins= true;
		
		if (_dir == 0 && 7 == dirSector[i] ){ bDirMoins = true; }
		if( _dir == 7 && 0 == dirSector[i] ) { bDirPlus = true; }
	}
	
	if(bDir ){
		if( bDirPlus || bDirMoins ){
			res = 1;
		}else{
			res = 2;
		}
	}else{
		res = -1;
	}
	
	return res;
}

//========================
int GMConfiguration::getNbBranchForDir(int _dir){
	int res = 0;
	for(unsigned int i =0; i < dirSector.size() ; i ++){
		if(_dir == dirSector[i] ) { res ++; }
	}
	return res;
}


//========================
int GMConfiguration::getAngle8From64(int _angle){
	int res = -1;
	int diff = 0;
	for(int i = 0; i <7; i++){
		if (_angle > 8* i + 4 && _angle <= 8 *(i +1) +4){
			res =  (i+1);
			if( _angle >= 8 *( i + 1) ){
				diff = 1;
			}else{
				diff = -1;
			}
			
		}
	}
	
	if(res == -1){
		res = 0;
		if (_angle >= 0){
			diff = 1;
		}else{
			diff = -1;
		}
	}
	//cerr<<"getAngle8_64 ="<<res<<" dif = "<<diff;
	
	
	int nbBranch = getNbBranchForDir( res);
	if( nbBranch == 0 ){
		int res2 = res + diff;
		//cerr<<"res 2 = "<<res2<<endl;
		
		if(res2 ==8){ res2 = 0; }
		if(res2 == -1) { res2 = 7; }
		
		int ampl = getAmplForDir(res2);
		if(ampl == 2){
			res = res2;
		}
		
	}
	
	
	
	return res;
}

//======================
int GMConfiguration::getBranch(int angleG, int angle, int _ampl, int nbBranch){
	int res = -1;
	int angleMean = angleG * 8;
	int ampl = _ampl * 64 / 8;
	
	if(nbBranch == 1){
		res = 0;
		
	}else if (nbBranch == 2){
		if(angle > angleMean){
			res =1;
		}else{
			res =2;
		}
		
		
	}else if (nbBranch == 3){
		int temp = angleMean - ampl/6;
		if(temp < 0){ temp = 64 - ampl/6; }
		
		if(angle > angleMean + 	ampl /6){
			res = 4;
		}else if (angle < temp ){
			res = 3;
		}else{
			res = 0;
		}
		
	}else if (nbBranch == 4){
		if(angleMean == 0){
			int temp = angleMean - ampl/8;
			if(temp < 0){
				temp = 64 - ampl/8;
			}
			
			
			if(angle > angleMean + 	ampl /8 && angle<32){
				res = 4;
			}else if (angle >= angleMean   && angle < 32 ){
				res = 2;
			}else if (angle < temp){
				res = 3;
			}else{
				res = 1;
			}
			
			
		}else{
			
			if(angle > angleMean + 	ampl /8){
				res = 4;
			}else if (angle >= angleMean){
				res = 2;
			}else if (angle < angleMean - ampl/8){
				res = 3;
			}else{
				res = 1;
			}
			
		}
	}
	
	
	
	return res;
}
















