/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : jeudi 26 avril 2007 - 11h43
		* AUTHOR       : gilles bailly ( gilles.bailly@enst.fr )
			* FILENAME     : RadialSector.cpp
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/
//RadialSector.cpp

#include <iostream>
#include <math.h>
#include <QPainter>
#include <QRectF>
#include <QColor>
#include <QEvent>
#include <QMouseEvent>
#include <QPoint>
#include <QPushButton>
#include <QLabel>

#include "RadialSector.h"
#include "RadialMenu.h"

using namespace std;

vector<QPointF> RadialSector::position;


//TODO le mainWidget est cree dans le constructeur moyen
//menu depth pas implemente
//attention a intialize elle n'appelle plus initpositions et getDecalage

//=================
RadialSector::RadialSector(const QString& text, QWidget* parent,
		Qt::WindowFlags _f): QWidget(parent), id(-1), name(text){
			setMouseTracking(true);
	move(0,0);
	resize(1000, 1000);
	
#if defined(Q_OS_WIN)	
	QPushButton& button = *new QPushButton(name, this);
	mainWidget = &button;
#elif defined(Q_OS_MAC)
   QLabel& label = *new QLabel(name, this);
	label.setAlignment( Qt::AlignCenter );
	mainWidget = &label;
#endif
		
	//mainWidget->show();
	//mainWidget->resize( mainWidget->minimumSize() );
	
	setAutoFillBackground(false);
}

//=================
QString RadialSector::text(){
	if(mainWidget){
#if defined(Q_OS_WIN)	
		QPushButton* b = qobject_cast< QPushButton* > (mainWidget);
#elif defined(Q_OS_MAC)
		QLabel* b = qobject_cast< QLabel* > (mainWidget);
#endif

		if(b){
			return b->text();
		}
	}
	return "non valide";
}

//=================
void RadialSector::initialize(){
	move(0,0);
	resize(1000,1000);
	
	RadialMenu* m = qobject_cast<RadialMenu *> ( parent() );
	if(!m){ cerr<<"error radialMenu initialize"<<endl; }
	
	mainWidget->setFont( m->font()  );
	mainWidget->setAutoFillBackground(true);
	QPalette p(mainWidget->palette());
	p.setColor(mainWidget->backgroundRole(), QColor(255,255,255));
	mainWidget->setPalette(p);
	
}

//=================
RadialSector::~RadialSector(){
	if(mainWidget){
		//delete mainWidget; mainWidget = 0;
	}
}

//==================
void RadialSector::paintEvent(QPaintEvent* e){}

//=================
bool RadialSector::eventFilter(QObject* obj, QEvent* e){
	return false;
	//return QObject::eventFilter( obj, e );
	
}

//=================
int RadialSector::getId(){ return id; }

//==================
void RadialSector::setId(int _id){ id = _id; }

//=================
int RadialSector::menuDepth()const{
	cerr<<"WARNING NOT IMPLEMENTED"<<endl;
	return 1;
}

//=================
int RadialSector::itemWidth(){
	if(mainWidget){
		return mainWidget->width();
	}else{
		return -1;
	}
}

//===================
int RadialSector::itemX(){ return mainWidget->x(); }

//====================
void RadialSector::moveItem( int x, int y ){ mainWidget->move( x, y) ; }

//===================
int RadialSector::itemY(){ return mainWidget->y(); }


//===================
int RadialSector::itemHeight(){
	if(mainWidget){
		return mainWidget->height();
	}else{
		return -1;
	}
}

//=================
void RadialSector::itemResize(int w, int h){
	if(mainWidget){
		mainWidget->resize(w, h);
	}
}

//===================
bool RadialSector::itemContains(QPoint p){
	if(mainWidget){
		return mainWidget->geometry().contains(p);
	}
	return false;
}

//=================
void RadialSector::setItemDown(bool b){
	//cerr<<__PRETTY_FUNCTION__<<endl;
	//QPushButton* wid = (QPushButton*)mainWidget;
	
#if defined(Q_OS_WIN)	
		QPushButton* wid = qobject_cast< QPushButton* > (mainWidget);
#elif defined(Q_OS_MAC)
		QLabel* wid = qobject_cast< QLabel* > (mainWidget);
#endif
	
	
	if(wid){
		QPalette p(wid->palette());
		if(b){
			QColor color(150,150,255);
			p.setColor( wid->foregroundRole(), Qt::white);
			p.setColor( wid->backgroundRole(), color);
			
			
		}else{
			p.setColor( wid->foregroundRole(), Qt::black);
			p.setColor( wid->backgroundRole(), Qt::white);
		}
		wid->setPalette(p);
		wid->update();
#if defined(Q_OS_WIN)		
		wid->setDown(b);
#endif		
		//button->setFlat(b);
	}
}
